smsd(8)

NAME
smsd - daemon for handling incoming and outgoing SMSes using libgnokii

SYNOPSIS
smsd [OPTIONS]

DESCRIPTION

The SMSD (SMS daemon) program is intended for receiving and sending SMSes.

The program is designed to use modules (plugins) to work with different backends. Currently are supported PostgreSQL, MySQL and a special module 'file' which is designed to work without an SQL database (see below for special instructions in the file module section). When SMSD uses an SQL server as a repository for SMSes you must create a database (default name is 'sms') with tables defined in sms.tables.{module}.sql files. Table 'inbox' is for received SMSes. SMSD periodically checks a given phone memory to move messages to this table. Only received SMSes and status reports are deleted from the phone, other kinds of messages are not removed.

Table 'inbox' has the following fields:

    number
        phone number from which is sms received

    smsdate
        date set by SMS center

    insertdate
        date SMS was inserted into table

    text
        SMS text

    phone
        number of phone to use. If you use smsd without -t option you can ignore this column. See -t option below.

    processed
        smsd sets this always to FALSE. You can use it for another program which will parse SMSes.

Table 'outbox' is for outgoing SMSes. SMSD periodically looks into this table and searches for lines with attribute 'processed' set to FALSE. If it finds such SMS, it will send SMS to 'number'.

Table 'outbox' has the following fields:

    number
        recipient's phone number

    processed_date
        date of processing SMS.

    insertdate
        date of inserting SMS in table

    text
        SMS text

    phone
        number of phone to use. If you use smsd without -t option you must not fill this column. See -t option below.

    processed
        new SMS must have this attribute set to FALSE. SMSD will send this SMS and will update 'processed' to TRUE.

    error
        This attribute contains return value of gn_sms_send() function. For explanation of numeric values see <gnokii/error.h> in gnokii source.

    dreport
        request for delivery report per message. Possible values are 0 for no delivery report, 1 for delivery report.

    not_before
        sms will not be sent before this time (default 00:00:00).

    not_after
        sms will not be sent after this time (default 23:59:59).

SMSD is multi threaded program. If you list processes you will see more than one instance of smsd.

  THE FILE MODULE

This module doesn't need an SQL server to work. For incoming messages it works in a way that it calls a program giving phone number, date as parameter and the message text on stdin. In the smsd directory there is an example file action. It shows sms data to stdout. If you want something useful you must write your own action. For outgoing messages you can set spool directory where smsd looks regularly.

Incoming sms are passed in format
    action number date < sms

Outgoing sms must be in format:
    number
    text

The name of file is unimportant but smsd ignores all files with prefix "ERR.". If smsd succesfully sends sms, it removes file from spool directory. If smsd cannot send sms prepends file with "ERR." prefix and ignores it. If you use -m file, -u (--user) and -c (--host) will have other meaning. -u is for action (action must be executable) -c is for spool directory where smsd looks for smses. Smsd must have read and write permissions to this directory.

-p, -d parameters have no meaning when -m file is used.

If you don't specify -u, default action is to print sms to stdout. If you don't specify -c, sms sending will be disabled.

  OPTIONS

Available options:

-u, --user db_username
    Specify user name.

-p, --password db_password
    Specify user password.

-d, --db db_name
    Specify database name for 'pq' and 'mysql' modules or full path to database file for 'sqlite' module (defaults to 'sms').

-c, --host db_hostname
    Specify database server host name.

-s, --schema db_hostname
    Specify database schema used by the PostgreSQL module (defaults to 'public').

-e, --encoding client_encoding
    Specify client encoding for database connection.

-m, --module db_module
    Specify which module to use for connection to DB server. Currently supported values are 'pq' for PostgreSQL, 'mysql' for MySQL, 'sqlite' for SQLite3 and 'file'. File module is not supported in Windows.

-l, --libdir path_to_db_module
    Specify path to DB modules. If you specify pq module, smsd searches in libdir for file libsmsd_pq.so (for mysql - libsmsd_mysql.so). Do not interchange these plugins with default SQL libraries from database distribution!

-f, --logfile file
    If used, smsd will monitor sms traffic to file "file". File is reopened and closed for every message so you can simply rename or delete it if you want to rotate logs. If you use '-' as filename smsd will use standard output.

-t, --phone phone_number
    You can run more instances of smsd. One instance per phone. In this setup you must configure phone section in the config file. For example:
    [global]
    port = /dev/ttyS0
    model = 6110
    initlength = default
    connection = serial
    bindir = /usr/local/sbin/
    use_locking = no
    serial_baudrate = 38400
    smsc_timeout = 10
    [phone_1]
    port = /dev/ttyS0
    model = 6110
    initlength = default
    connection = serial
    bindir = /usr/local/sbin/
    use_locking = no
    serial_baudrate = 38400
    [phone_2]
    port = /dev/ttyS1
    model = AT
    initlength = default
    connection = serial
    bindir = /usr/local/sbin/
    use_locking = no
    serial_baudrate = 38400
    smsc_timeout = 10 In this setup if you run smsd without -t option it will use config from global section. If you run smsd with -t 1 it will use config from phone_1 and likewise with -t 2 uses phone_2. In case of use -t option smsd fills phone number for incoming sms's and in outbox it looks only for sms's with the specified phone number in column 'phone'. This behaviour gives you possibility to run one instance of smsd for every phone you have at the same time.

-i, --interval interval
    Polling interval for incoming sms's in seconds. Default is 1 second.

-S, --maxsms number
    When phone driver doesn't support sms status it is possible to specify number of sms's supported by phone. Default is 10. If driver support sms status this option is ignored.

-b, --inbox memory_type
    Where to look for new messages (defaults to IN for most Nokia phones and to SM for all other phones). For debugging or for unusual setups you can use another memory type supported by your phone (eg. IN for the Inbox, OU for the Outbox, AR for the Archive, TE for the Templates and F1,...,F20 for your own folders). Use gnokii --showsmsfolderstatus for a list of such memory types.

-0, --firstpos0
    SMSD starts messages reading from position 1. If your phone stores sms's from postion 0, use this option.

-v, --version
    Shows smsd version.

-h, --help
    Shows short help.

DIAGNOSTICS
Various error messages are printed to STDERR. Debug output can be enabled setting xdebug=on (for messages specific to SMSD) and debug=on (for messages specific to libgnokii) in the configuration file.

BUGS

None reported.

AUTHOR
SMSD was written by Jan Derfinak and contributed by other people. See also Docs/CREDITS from the Gnokii sources.

COPYING
This program is distributed under the GNU Public License.

SEE ALSO
gnokii(1)